// ============================================================================
// Project:	A Tiny DBMS (Exercise for Course "DBMS-Implementation")
// Filename:	main.cpp
// Purpose:	Main program
// Last Change:	21.02.2012
// Language:	C++
// Author:	Stefan Brass
// EMail:	brass@informatik.uni-halle.de
// WWW:		http://www.informatik.uni-halle.de/~brass/
// Address:	Feldschloesschen 15, D-06120 Halle (Saale), GERMANY
// Copyright:	(c) 2011-2012 by Stefan Brass
// Note:	There is no warranty at all - this code may contain bugs.
// ============================================================================


// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.


//=============================================================================
// Interface:
//=============================================================================

#include "ver.h"
#include "str.h"
#include "boff.h"
#include "block.h"

#pragma GCC diagnostic ignored "-Wunreachable-code"
#include <iostream>
#include <fstream>
using namespace std;


//=============================================================================
// Exported Functions:
//=============================================================================

//-----------------------------------------------------------------------------
// main: Main program.
//-----------------------------------------------------------------------------

int main()
{
	// Create a block object:
	block_c b;

	// Check size of block:
	cout << "Size of block object: " << sizeof(b) << "\n";
	if(sizeof(b) != VER_BLOCKSIZE)
		cout << "This is not the intended size!\n";

	// Check whether block is correct:
	str_t err = b.invalid();
	if(err)
		cout << "Block is damaged: " << err << ".\n";
	else
		cout << "Block is ok!\n";

	// Set block number:
	b.set_block_no(1);

	// Exchange partial write indicators:
	b.prepare_write();

	// Query the block number:
	cout << "Block number: " << b.block_no() << "\n";
	if(b.block_no() != 1)
		cout << "This is not the correct block number!\n";

	// Query the block type:
	cout << "Block type: " << btype_name(b.btype()) << "\n";

	// Check whether block is correct:
	err = b.invalid();
	if(err)
		cout << "Block is now damaged: " << err << ".\n";
	else
		cout << "Block is still ok!\n";

	// Terminate with success:
	return 0;
}

